searchNodes=[{"doc":"Client for the Microsoft Graph API . Usage client = Microsoft.Client . create ( &quot;client_id&quot; , &quot;client_secret&quot; , &quot;tenant_id&quot; ) |&gt; MicrosoftGraph.Client . get_token! ( scope : &quot;https://graph.microsoft.com/.default&quot; ) MicrosoftGraph.Users.User . list_users ( client ) # {:ok, response} MicrosoftGraph.Users.Photo . get_user_photo ( client , &quot;user_id&quot; ) # {:ok, response}","ref":"MicrosoftGraph.Client.html","title":"MicrosoftGraph.Client","type":"module"},{"doc":"Creates a new %OAuth2.Client{} struct configured for the Microsoft Graph API with an Ueberauth config. Example: iex&gt; Microsoft.Client . create ( Application . get_env ( :ueberauth , Ueberauth.Strategy.Microsoft.OAuth ) ) % OAuth2.Client { }","ref":"MicrosoftGraph.Client.html#create/1","title":"MicrosoftGraph.Client.create/1","type":"function"},{"doc":"Creates a new %OAuth2.Client{} struct configured for the Microsoft Graph API. Examples: iex&gt; Microsoft.Client . create ( &quot;client_id&quot; , &quot;client_secret&quot; , &quot;tenant_id&quot; ) % OAuth2.Client { }","ref":"MicrosoftGraph.Client.html#create/3","title":"MicrosoftGraph.Client.create/3","type":"function"},{"doc":"Default scope string helper. https://docs.microsoft.com/en-us/azure/active-directory/develop/v2-permissions-and-consent#the-default-scope","ref":"MicrosoftGraph.Client.html#default_scope/0","title":"MicrosoftGraph.Client.default_scope/0","type":"function"},{"doc":"Gets a token and puts the correct json header for the API. Example # Returns a client with a valid access token iex&gt; MicrosoftGraph.Client . get_token! ( % OAuth2.Client { } ) % OAuth2.Client { }","ref":"MicrosoftGraph.Client.html#get_token!/4","title":"MicrosoftGraph.Client.get_token!/4","type":"function"},{"doc":"https://docs.microsoft.com/en-us/graph/api/resources/groups-overview?view=graph-rest-1.0","ref":"MicrosoftGraph.Groups.Group.html","title":"MicrosoftGraph.Groups.Group","type":"module"},{"doc":"Get a group by its id. https://docs.microsoft.com/en-us/graph/api/group-get?view=graph-rest-1.0&amp;tabs=http","ref":"MicrosoftGraph.Groups.Group.html#get_group/3","title":"MicrosoftGraph.Groups.Group.get_group/3","type":"function"},{"doc":"List all groups. https://docs.microsoft.com/en-us/graph/api/group-list?view=graph-rest-1.0&amp;tabs=http","ref":"MicrosoftGraph.Groups.Group.html#list_groups/2","title":"MicrosoftGraph.Groups.Group.list_groups/2","type":"function"},{"doc":"List all members of a group. To get all members recursively, use list_transitive_members/3 . https://docs.microsoft.com/en-us/graph/api/group-list-members?view=graph-rest-1.0&amp;tabs=http","ref":"MicrosoftGraph.Groups.Group.html#list_members/3","title":"MicrosoftGraph.Groups.Group.list_members/3","type":"function"},{"doc":"List all members of a group and all child groups. https://docs.microsoft.com/en-us/graph/api/group-list-transitivemembers?view=graph-rest-1.0&amp;tabs=http","ref":"MicrosoftGraph.Groups.Group.html#list_transitive_members/3","title":"MicrosoftGraph.Groups.Group.list_transitive_members/3","type":"function"},{"doc":"Lower-level API to create and execute Microsoft Graph API requests.","ref":"MicrosoftGraph.Request.html","title":"MicrosoftGraph.Request","type":"module"},{"doc":"Create a DELETE request. See new/1 for options.","ref":"MicrosoftGraph.Request.html#delete/2","title":"MicrosoftGraph.Request.delete/2","type":"function"},{"doc":"Executes a given request. Example iex&gt; MicrosoftGraph.Request . execute ( % Request { } , % OAuth2.Client { } ) { :ok , response } # Bad request iex&gt; MicrosoftGraph.Request . execute ( % Request { } , % OAuth2.Client { } ) { :error , response } # Unsupported method iex&gt; MicrosoftGraph.Request . execute ( % Request { method : :grab } , % OAuth2.Client { } ) { :error , :unsupported_method }","ref":"MicrosoftGraph.Request.html#execute/2","title":"MicrosoftGraph.Request.execute/2","type":"function"},{"doc":"Create a GET request. See new/1 for options.","ref":"MicrosoftGraph.Request.html#get/2","title":"MicrosoftGraph.Request.get/2","type":"function"},{"doc":"Create a request. You generally should use the other request constructors like get/2 and post/2 . Basic request options: :method - the request method, defaults to :get. :url - the request URL. :headers - the request headers. The headers are automatically encoded using these rules: atom header names are turned into strings string header names are left as is. :params - the request params (querystring for get, post body for post,put,patch). :cast - OData cast, defaults to nothing Options are: :user for microsoft.graph.user :group for microsoft.graph.group","ref":"MicrosoftGraph.Request.html#new/1","title":"MicrosoftGraph.Request.new/1","type":"function"},{"doc":"Will make request a paginated request. execute/2 will follow the @odata.nextLink in the response if it exists to fetch the next page. Method type will be :get_paginated .","ref":"MicrosoftGraph.Request.html#paginate_results/1","title":"MicrosoftGraph.Request.paginate_results/1","type":"function"},{"doc":"Create a PATCH request. See new/1 for options.","ref":"MicrosoftGraph.Request.html#patch/2","title":"MicrosoftGraph.Request.patch/2","type":"function"},{"doc":"Create a POST request. See new/1 for options.","ref":"MicrosoftGraph.Request.html#post/2","title":"MicrosoftGraph.Request.post/2","type":"function"},{"doc":"Create a PUT request. See new/1 for options.","ref":"MicrosoftGraph.Request.html#put/2","title":"MicrosoftGraph.Request.put/2","type":"function"},{"doc":"Puts the advanced query params and headers required for some operations. https://docs.microsoft.com/en-us/graph/aad-advanced-queries?tabs=http","ref":"MicrosoftGraph.Request.html#put_advanced_query_params/1","title":"MicrosoftGraph.Request.put_advanced_query_params/1","type":"function"},{"doc":"Puts a header into the given request. Example iex&gt; MicrosoftGraph.Request . put_header ( % Request { } , &quot;Content-Type&quot; , &quot;application/json&quot; ) % Request { }","ref":"MicrosoftGraph.Request.html#put_header/3","title":"MicrosoftGraph.Request.put_header/3","type":"function"},{"doc":"","ref":"MicrosoftGraph.Request.html#t:t/0","title":"MicrosoftGraph.Request.t/0","type":"type"},{"doc":"An app role assignment is a relationship between the assigned principal (a user, a group, or a service principal), a resource application (the app's service principal) and an app role defined on the resource application. https://docs.microsoft.com/en-us/graph/api/resources/approleassignment?view=graph-rest-1.0","ref":"MicrosoftGraph.Users.AppRoleAssignments.html","title":"MicrosoftGraph.Users.AppRoleAssignments","type":"module"},{"doc":"https://docs.microsoft.com/en-us/graph/api/user-list-approleassignments?view=graph-rest-1.0&amp;tabs=http Examples iex&gt; MicrosoftGraph.Users.AppRoleAssignments . list_app_role_assignments ( client , &quot;1234...&quot; ) { :ok , response } # Filter by resourceId (Application ID) iex&gt; MicrosoftGraph.Users.AppRoleAssignments . list_app_role_assignments ( client , &quot;1234...&quot; , params : %{ &quot;$filter&quot; =&gt; &quot;resourceId eq \#{ application_id } &quot; } ) { :ok , response }","ref":"MicrosoftGraph.Users.AppRoleAssignments.html#list_app_role_assignments/3","title":"MicrosoftGraph.Users.AppRoleAssignments.list_app_role_assignments/3","type":"function"},{"doc":"https://docs.microsoft.com/en-us/graph/api/resources/calendar?view=graph-rest-1.0","ref":"MicrosoftGraph.Users.Calendar.html","title":"MicrosoftGraph.Users.Calendar","type":"module"},{"doc":"Removes the specified event from the containing calendar. https://learn.microsoft.com/en-us/graph/api/event-delete?view=graph-rest-1.0&amp;tabs=http Examples # Params are NOT required for this endpoint iex&gt; MicrosoftGraph.Users.Calendar . delete_meeting ( client , &quot;user_id&quot; , &quot;meeting_id&quot; ) { :ok , response }","ref":"MicrosoftGraph.Users.Calendar.html#delete_meeting/4","title":"MicrosoftGraph.Users.Calendar.delete_meeting/4","type":"function"},{"doc":"Suggest meeting times and locations based on organizer and attendee availability, and time or location constraints specified as parameters. https://learn.microsoft.com/en-us/graph/api/user-findmeetingtimes?view=graph-rest-1.0&amp;tabs=http Examples # Params are required for this endpoint iex&gt; MicrosoftGraph.Users.Calendar . find_meeting_times ( client , &quot;user_id&quot; ) { :error , response } iex&gt; MicrosoftGraph.Users.Calendar . find_meeting_times ( client , &quot;user_id&quot; , params : %{ &quot;attendees&quot; : [ %{ &quot;emailAddress&quot; : %{ &quot;address&quot; : &quot;{user-mail}&quot; , &quot;name&quot; : &quot;Alex Darrow&quot; } , &quot;type&quot; : &quot;Required&quot; } ] , &quot;timeConstraint&quot; : %{ &quot;timeslots&quot; : [ %{ &quot;start&quot; : %{ &quot;dateTime&quot; : &quot;2022-11-02T23:35:18.469Z&quot; , &quot;timeZone&quot; : &quot;Pacific Standard Time&quot; } , &quot;end&quot; : %{ &quot;dateTime&quot; : &quot;2022-11-09T23:35:18.469Z&quot; , &quot;timeZone&quot; : &quot;Pacific Standard Time&quot; } } ] } , &quot;locationConstraint&quot; : %{ &quot;isRequired&quot; : &quot;false&quot; , &quot;suggestLocation&quot; : &quot;true&quot; , &quot;locations&quot; : [ %{ &quot;displayName&quot; : &quot;Conf Room 32/1368&quot; , &quot;locationEmailAddress&quot; : &quot;conf32room1368@imgeek.onmicrosoft.com&quot; } ] } , &quot;meetingDuration&quot; : &quot;PT1H&quot; } ) { :ok , response }","ref":"MicrosoftGraph.Users.Calendar.html#find_meeting_times/3","title":"MicrosoftGraph.Users.Calendar.find_meeting_times/3","type":"function"},{"doc":"Get the free/busy availability information for a collection of users, distributions lists, or resources (rooms or equipment) for a specified time period. https://docs.microsoft.com/en-us/graph/api/calendar-getschedule?view=graph-rest-1.0&amp;tabs=http Examples # Params are required for this endpoint iex&gt; MicrosoftGraph.Users.Calendar . get_schedule ( client , &quot;user_id&quot; ) { :error , response } iex&gt; MicrosoftGraph.Users.Calendar . get_schedule ( client , &quot;user_id&quot; , params : %{ schedules : [ &quot;user_email&quot; ] , startTime : %{ dateTime : NaiveDateTime . utc_now ( ) , timeZone : &quot;UTC&quot; } , endTime : %{ dateTime : NaiveDateTime . utc_now ( ) |&gt; NaiveDateTime . add ( 3600 , :second ) , timeZone : &quot;UTC&quot; } , availabilityViewInterval : 15 } ) { :ok , response }","ref":"MicrosoftGraph.Users.Calendar.html#get_schedule/3","title":"MicrosoftGraph.Users.Calendar.get_schedule/3","type":"function"},{"doc":"Create an event in the user's default calendar or specified calendar. https://learn.microsoft.com/en-us/graph/api/user-post-events?view=graph-rest-1.0&amp;tabs=http Examples # Params are required for this endpoint iex&gt; MicrosoftGraph.Users.Calendar . schedule_meeting ( client , &quot;user_id&quot; ) { :error , response } iex&gt; MicrosoftGraph.Users.Calendar . schedule_meeting ( client , &quot;user_id&quot; , params : %{ &quot;subject&quot; : &quot;Let&#39;s go for lunch&quot; , &quot;body&quot; : %{ &quot;contentType&quot; : &quot;HTML&quot; , &quot;content&quot; : &quot;Does noon work for you?&quot; } , &quot;start&quot; : %{ &quot;dateTime&quot; : &quot;2017-04-15T12:00:00&quot; , &quot;timeZone&quot; : &quot;Pacific Standard Time&quot; } , &quot;end&quot; : %{ &quot;dateTime&quot; : &quot;2017-04-15T14:00:00&quot; , &quot;timeZone&quot; : &quot;Pacific Standard Time&quot; } , &quot;location&quot; : %{ &quot;displayName&quot; :&quot;Harry&#39;s Bar&quot; } , &quot;attendees&quot; : [ %{ &quot;emailAddress&quot; : %{ &quot;address&quot; :&quot;samanthab@contoso.onmicrosoft.com&quot; , &quot;name&quot; : &quot;Samantha Booth&quot; } , &quot;type&quot; : &quot;required&quot; } ] , &quot;allowNewTimeProposals&quot; : true } ) { :ok , response }","ref":"MicrosoftGraph.Users.Calendar.html#schedule_meeting/3","title":"MicrosoftGraph.Users.Calendar.schedule_meeting/3","type":"function"},{"doc":"Update the properties of the event object. https://learn.microsoft.com/en-us/graph/api/event-update?view=graph-rest-1.0&amp;tabs=http Examples # Params are required for this endpoint iex&gt; MicrosoftGraph.Users.Calendar . update_meeting ( client , &quot;user_id&quot; , &quot;meeting_id&quot; ) { :error , response } iex&gt; MicrosoftGraph.Users.Calendar . update_meeting ( client , &quot;user_id&quot; , , &quot;meeting_id&quot; , params : %{ &quot;body&quot; : %{ &quot;contentType&quot; : &quot;HTML&quot; , &quot;content&quot; : &quot;Does noon work for you??&quot; } } ) { :ok , response }","ref":"MicrosoftGraph.Users.Calendar.html#update_meeting/4","title":"MicrosoftGraph.Users.Calendar.update_meeting/4","type":"function"},{"doc":"","ref":"MicrosoftGraph.Users.Org.html","title":"MicrosoftGraph.Users.Org","type":"module"},{"doc":"Assign direct manager for given user. https://learn.microsoft.com/en-us/graph/api/user-post-manager?view=graph-rest-1.0&amp;tabs=http Examples # $ref is passed in as the @odata.id iex&gt; MicrosoftGraph.Users.Org . assign_manager ( client , &quot;user_id&quot; , params : %{ &quot;@odata.id&quot; : &quot;https://graph.microsoft.com/v1.0/users/6ea91a8d-e32e-41a1-b7bd-d2d185eed0e0&quot; } ) { :ok , response }","ref":"MicrosoftGraph.Users.Org.html#assign_manager/3","title":"MicrosoftGraph.Users.Org.assign_manager/3","type":"function"},{"doc":"List all managers recursively for given user. https://learn.microsoft.com/en-us/graph/api/user-list-manager?view=graph-rest-1.0&amp;tabs=http Examples # At a minimum, `$expand=manager($levels=max;)` is required iex&gt; MicrosoftGraph.Users.Org . get_manager ( client , &quot;user_id&quot; , params : %{ &quot;$expand&quot; =&gt; &quot;manager($levels=max;)&quot; } ) { :ok , response } iex&gt; MicrosoftGraph.Users.Org . get_manager ( client , &quot;user_id&quot; , params : %{ &quot;$expand&quot; =&gt; &quot;manager($levels=max;$select=id,displayName)&quot; , &quot;$select&quot; =&gt; &quot;id,displayName&quot; , &quot;$count&quot; =&gt; true } ) { :ok , response }","ref":"MicrosoftGraph.Users.Org.html#get_all_managers/3","title":"MicrosoftGraph.Users.Org.get_all_managers/3","type":"function"},{"doc":"List direct manager for given user. https://learn.microsoft.com/en-us/graph/api/user-list-manager?view=graph-rest-1.0&amp;tabs=http Examples iex&gt; MicrosoftGraph.Users.Org . get_manager ( client , &quot;user_id&quot; ) { :ok , response }","ref":"MicrosoftGraph.Users.Org.html#get_manager/3","title":"MicrosoftGraph.Users.Org.get_manager/3","type":"function"},{"doc":"List direct reports for given user. https://learn.microsoft.com/en-us/graph/api/user-list-directreports?view=graph-rest-1.0&amp;tabs=http Examples iex&gt; MicrosoftGraph.Users.Org . list_direct_reports ( client , &quot;user_id&quot; ) { :ok , response }","ref":"MicrosoftGraph.Users.Org.html#list_direct_reports/3","title":"MicrosoftGraph.Users.Org.list_direct_reports/3","type":"function"},{"doc":"https://docs.microsoft.com/en-us/graph/api/resources/profilephoto?view=graph-rest-1.0","ref":"MicrosoftGraph.Users.Photo.html","title":"MicrosoftGraph.Users.Photo","type":"module"},{"doc":"Returns the actual user photo binary data. Examples iex&gt; Microsoft.Photo . get_photo ( client , &quot;user_id&quot; ) { :ok , response }","ref":"MicrosoftGraph.Users.Photo.html#get_user_photo/3","title":"MicrosoftGraph.Users.Photo.get_user_photo/3","type":"function"},{"doc":"Gets the data about a user's profile photo. Examples iex&gt; Microsoft.Photo . get_user_photo_metadata ( client , &quot;user_id&quot; ) { :ok , response }","ref":"MicrosoftGraph.Users.Photo.html#get_user_photo_metadata/3","title":"MicrosoftGraph.Users.Photo.get_user_photo_metadata/3","type":"function"},{"doc":"Users API. https://docs.microsoft.com/en-us/graph/api/resources/user?view=graph-rest-1.0","ref":"MicrosoftGraph.Users.User.html","title":"MicrosoftGraph.Users.User","type":"module"},{"doc":"Create a user. https://docs.microsoft.com/en-us/graph/api/user-post-users?view=graph-rest-1.0&amp;tabs=http Example: iex&gt; MicrosoftGraph.Users.User . create_user ( client , params : %{ &quot;accountEnabled&quot; =&gt; true , &quot;displayName&quot; =&gt; &quot;Adele Vance&quot; , &quot;mailNickname&quot; =&gt; &quot;AdeleV&quot; , &quot;userPrincipalName&quot; =&gt; &quot;AdeleV@contoso.onmicrosoft.com&quot; , &quot;passwordProfile&quot; =&gt; %{ &quot;forceChangePasswordNextSignIn&quot; =&gt; true , &quot;password&quot; =&gt; &quot;password1234&quot; } } ) { :ok , response }","ref":"MicrosoftGraph.Users.User.html#create_user/2","title":"MicrosoftGraph.Users.User.create_user/2","type":"function"},{"doc":"https://docs.microsoft.com/en-us/graph/api/user-get?view=graph-rest-1.0&amp;tabs=http Examples iex&gt; MicrosoftGraph.Users.User . get_user ( client , &quot;1234...&quot; ) { :ok , response } # With query params iex&gt; MicrosoftGraph.Users.User . get_user ( client , &quot;1234...&quot; , params : %{ &quot;$select&quot; =&gt; &quot;displayName,id&quot; , &quot;$filter&quot; =&gt; &quot;identities/any(c:c/issuerAssignedId eq &#39;j.smith@yahoo.com&#39; and c/issuer eq &#39;My B2C tenant&#39;&quot; } ) { :ok , response }","ref":"MicrosoftGraph.Users.User.html#get_user/3","title":"MicrosoftGraph.Users.User.get_user/3","type":"function"},{"doc":"https://docs.microsoft.com/en-us/graph/api/user-list?view=graph-rest-1.0&amp;tabs=http Examples iex&gt; MicrosoftGraph.Users.User . list_users ( client ) { :ok , response } # Filter results iex&gt; MicrosoftGraph.Users.User . list_users ( client , params : %{ &quot;$filter&quot; =&gt; &quot;userType eq &#39;Member&#39; and accountEnabled eq true&quot; } ) { :ok , response }","ref":"MicrosoftGraph.Users.User.html#list_users/2","title":"MicrosoftGraph.Users.User.list_users/2","type":"function"}]